// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from marine_sensor_msgs:msg/TurbidityNTU.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "marine_sensor_msgs/msg/turbidity_ntu.h"


#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__FUNCTIONS_H_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "marine_sensor_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marine_sensor_msgs/msg/detail/turbidity_ntu__struct.h"

/// Initialize msg/TurbidityNTU message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marine_sensor_msgs__msg__TurbidityNTU
 * )) before or use
 * marine_sensor_msgs__msg__TurbidityNTU__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__TurbidityNTU__init(marine_sensor_msgs__msg__TurbidityNTU * msg);

/// Finalize msg/TurbidityNTU message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__TurbidityNTU__fini(marine_sensor_msgs__msg__TurbidityNTU * msg);

/// Create msg/TurbidityNTU message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marine_sensor_msgs__msg__TurbidityNTU__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
marine_sensor_msgs__msg__TurbidityNTU *
marine_sensor_msgs__msg__TurbidityNTU__create(void);

/// Destroy msg/TurbidityNTU message.
/**
 * It calls
 * marine_sensor_msgs__msg__TurbidityNTU__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__TurbidityNTU__destroy(marine_sensor_msgs__msg__TurbidityNTU * msg);

/// Check for msg/TurbidityNTU message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__TurbidityNTU__are_equal(const marine_sensor_msgs__msg__TurbidityNTU * lhs, const marine_sensor_msgs__msg__TurbidityNTU * rhs);

/// Copy a msg/TurbidityNTU message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__TurbidityNTU__copy(
  const marine_sensor_msgs__msg__TurbidityNTU * input,
  marine_sensor_msgs__msg__TurbidityNTU * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
const rosidl_type_hash_t *
marine_sensor_msgs__msg__TurbidityNTU__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
const rosidl_runtime_c__type_description__TypeDescription *
marine_sensor_msgs__msg__TurbidityNTU__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
const rosidl_runtime_c__type_description__TypeSource *
marine_sensor_msgs__msg__TurbidityNTU__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
marine_sensor_msgs__msg__TurbidityNTU__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/TurbidityNTU messages.
/**
 * It allocates the memory for the number of elements and calls
 * marine_sensor_msgs__msg__TurbidityNTU__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__TurbidityNTU__Sequence__init(marine_sensor_msgs__msg__TurbidityNTU__Sequence * array, size_t size);

/// Finalize array of msg/TurbidityNTU messages.
/**
 * It calls
 * marine_sensor_msgs__msg__TurbidityNTU__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__TurbidityNTU__Sequence__fini(marine_sensor_msgs__msg__TurbidityNTU__Sequence * array);

/// Create array of msg/TurbidityNTU messages.
/**
 * It allocates the memory for the array and calls
 * marine_sensor_msgs__msg__TurbidityNTU__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
marine_sensor_msgs__msg__TurbidityNTU__Sequence *
marine_sensor_msgs__msg__TurbidityNTU__Sequence__create(size_t size);

/// Destroy array of msg/TurbidityNTU messages.
/**
 * It calls
 * marine_sensor_msgs__msg__TurbidityNTU__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
void
marine_sensor_msgs__msg__TurbidityNTU__Sequence__destroy(marine_sensor_msgs__msg__TurbidityNTU__Sequence * array);

/// Check for msg/TurbidityNTU message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__TurbidityNTU__Sequence__are_equal(const marine_sensor_msgs__msg__TurbidityNTU__Sequence * lhs, const marine_sensor_msgs__msg__TurbidityNTU__Sequence * rhs);

/// Copy an array of msg/TurbidityNTU messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_marine_sensor_msgs
bool
marine_sensor_msgs__msg__TurbidityNTU__Sequence__copy(
  const marine_sensor_msgs__msg__TurbidityNTU__Sequence * input,
  marine_sensor_msgs__msg__TurbidityNTU__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__FUNCTIONS_H_
